/*
 * Copyright 2010-2011 NEC Infrontia Corp, Inc.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * QorIQ NEC-I CCPU boards configuration file
 */
#ifndef __CONFIG_H
#define __CONFIG_H

#ifdef CONFIG_36BIT
#error	not supported
#endif


#if defined(CONFIG_CCPU)
#define CONFIG_BOARDNAME "CD-CP01"
#define CONFIG_P1024
#define CONFIG_MP
#define CONFIG_SPI_FLASH
#define __LOW_FLASH		/* Flash 16MB, undef 128MB */
#define LOCAL_VERSION "NEC-i Version 0.41"
#else
#error	not supported
#endif

#ifdef __LOW_FLASH
#define CONFIG_SYS_MAX_FLASH_SECT	128			/* 16MB */
#define CONFIG_FLASH_OR_AM			OR_AM_16MB
#define CONFIG_SYS_FLASH_BASE		0xef000000
#define CONFIG_MAC_ADDR				0xef020000
 #define CONFIG_MAC_SECT_SIZE   	 0x20000
#define CONFIG_2NDBOOT_ADDR			0xef040000	/* 2nd Boot addr */
 #define CONFIG_2NDBOOT_SECT_SIZE    0x2e0000
#else
#define CONFIG_SYS_MAX_FLASH_SECT	1024   		/* 128MB */
#define CONFIG_FLASH_OR_AM			OR_AM_128MB
#define CONFIG_SYS_FLASH_BASE		0xe8000000
#define CONFIG_MAC_ADDR				0xe8020000
 #define CONFIG_MAC_SECT_SIZE   	 0x20000
#define CONFIG_2NDBOOT_ADDR			0xe8040000	/* 2nd Boot addr */
 #define CONFIG_2NDBOOT_SECT_SIZE    0x2e0000
#endif

#define CONFIG_SYS_TEXT_BASE		0xeff80000
 #define CONFIG_SYS_TEXT_SECT_SIZE   0x80000
#define CONFIG_BOARD_SIZE_LIMIT  $$((512*1024))
#define CONFIG_RESET_VECTOR_ADDRESS	0xeffffffc
#define CONFIG_SYS_MONITOR_BASE		CONFIG_SYS_TEXT_BASE	/* start of monitor */

/* High Level Configuration Options */
#define CONFIG_BOOKE
#define CONFIG_E500
#define CONFIG_MPC85xx

#define CONFIG_FSL_ELBC

#define CONFIG_FSL_LAW
#define CONFIG_TSEC_ENET	/* tsec ethernet support */
#define CONFIG_ENV_OVERWRITE

#ifndef __ASSEMBLY__
extern unsigned long get_board_sys_clk(unsigned long dummy);
extern unsigned long get_board_ddr_clk(unsigned long dummy);
#endif
#define CONFIG_SYS_CLK_FREQ	get_board_sys_clk(0) /* SYSCLK */
#define CONFIG_DDR_CLK_FREQ	get_board_ddr_clk(0) /* DDRCLK */

#define CONFIG_HWCONFIG
/*
 * These can be toggled for performance analysis, otherwise use default.
 */
#define CONFIG_L2_CACHE
#define CONFIG_BTB

#define CONFIG_BOARD_EARLY_INIT_F	/* Call board_pre_init */
#define CONFIG_LAST_STAGE_INIT

#define CONFIG_SYS_DRAM_TEST
#define CONFIG_SYS_MEMTEST_START	0x00000000	/* memtest works on */
#define CONFIG_SYS_MEMTEST_END		0x1fffffff
/*#define CONFIG_PANIC_HANG */	/* do not reset board on panic */

/*
 * Base addresses -- Note these are effective addresses where the
 * actual resources get mapped (not physical addresses)
 */
#define CONFIG_SYS_CCSRBAR			0xffe00000	/* relocated CCSRBAR */
#define CONFIG_SYS_CCSRBAR_DEFAULT	0xff700000	/* CCSRBAR Default */

/* CCSRBAR PHYSICAL Address */
#define CONFIG_SYS_CCSRBAR_PHYS	CONFIG_SYS_CCSRBAR	/* physical addr of */
#define CONFIG_SYS_IMMR	CONFIG_SYS_CCSRBAR	/* PQII uses */

/* DDR Setup */
#define CONFIG_FSL_DDR3

#define CONFIG_SYS_SDRAM_SIZE_LAW	LAW_SIZE_512M
#define CONFIG_CHIP_SELECTS_PER_CTRL	1
#define CONFIG_SYS_SDRAM_SIZE		(1u << (CONFIG_SYS_SDRAM_SIZE_LAW - 19))
#define CONFIG_SYS_DDR_SDRAM_BASE	0x00000000
#define CONFIG_SYS_SDRAM_BASE		CONFIG_SYS_DDR_SDRAM_BASE

#define CONFIG_NUM_DDR_CONTROLLERS	1
#define CONFIG_DIMM_SLOTS_PER_CTLR	1

/* Default settings for DDR3 CL5,ECC */
#define CONFIG_SYS_DDR_CS0_BNDS			/*H'0000_2000*/	0x0000001f
#define CONFIG_SYS_DDR_CS0_CONFIG		/*H'0000_2080*/	0x80014202
#define CONFIG_SYS_DDR_CS0_CONFIG_2					   	0x00000000
#define CONFIG_SYS_DDR_TIMING_3			/*H'0000_2100*/	0x00020000
#define CONFIG_SYS_DDR_TIMING_0			/*H'0000_2104*/	0x00110104
#define CONFIG_SYS_DDR_TIMING_1			/*H'0000_2108*/	0x5c59e544
#define CONFIG_SYS_DDR_TIMING_2			/*H'0000_210C*/	0x0fa888ce
#define CONFIG_SYS_DDR_CONTROL			/*H'0000_2110*/	0xe70c0008
#define CONFIG_SYS_DDR_CONTROL_2		/*H'0000_2114*/	0x24401010
#define CONFIG_SYS_DDR_MODE_1			/*H'0000_2118*/	0x00441210
#define CONFIG_SYS_DDR_MODE_2			/*H'0000_211C*/	0x00000000
#define CONFIG_SYS_DDR_MODE_CONTROL		/*H'0000_2120*/	0x00000000
#define CONFIG_SYS_DDR_INTERVAL			/*H'0000_2124*/	0x0a280100
#define CONFIG_SYS_DDR_DATA_INIT		/*H'0000_2128*/	0x00000000
#define CONFIG_SYS_DDR_CLK_CTRL			/*H'0000_2130*/	0x03000000
#define CONFIG_SYS_DDR_INIT_ADDR					   	0x00000000
#define CONFIG_SYS_DDR_INIT_EXT_ADDR	/*H'0000_214C*/	0x00000000
#define CONFIG_SYS_DDR_TIMING_4			/*H'0000_2160*/	0x00000001
#define CONFIG_SYS_DDR_TIMING_5			/*H'0000_2164*/	0x01401400
#define CONFIG_SYS_DDR_ZQ_CONTROL		/*H'0000_2170*/	0x89080600
#define CONFIG_SYS_DDR_WRLVL_CONTROL	/*H'0000_2174*/	0x8675f608
#define CONFIG_SYS_DDR_SR_CNTR			/*H'0000_217C*/	0x00000000
#define CONFIG_SYS_DDR_RCW_1			/*H'0000_2180*/	0x00000000
#define CONFIG_SYS_DDR_RCW_2			/*H'0000_2184*/	0x00000000



#undef CONFIG_CLOCKS_IN_MHZ

/*
 * Memory map
 *
 * 0000_0000	-	1FFF_FFFF		MCS0	512MB	DDR3 SDRAM cacheable
 * 2000_0000	-	3FFF_FFFF				        reserve
 *
 * Localbus non-cacheable
 * EF00_0000	-	EFFF_FFFF		CS0		16MB	NOR FLASH non-cacheable
 * E800_0000	-	EFFF_FFFF						reserve
 * F900_0000	-	F91F_FFFF		CS1		2MB		SRAM
 * FC00_0000	-	FC00_FFFF		CS2		64KB	CPLD(=>FPGA)
 * FB00_0000	-	FB00_FFFF		CS3		64KB	DSP (HostDMA:2words)
 * FFD0_0000	-	FFD0_3FFF				16K		L1 for stack cacheable TLB0
 * FFE0_0000	-	FFEF_FFFF		IMMR	1MB		CCSR
 */

#define CONFIG_SYS_LBC_LBCR	0x00200000						/* LB config reg, AHD */
#define CONFIG_SYS_LBC_LCRR	(LCRR_CLKDIV_4 | LCRR_EADC_2)	/* LB clock ratio reg */

/*
 * Local Bus Definitions
 */
#define CONFIG_SYS_FLASH_BASE_PHYS	CONFIG_SYS_FLASH_BASE
#define CONFIG_FLASH_BR_PRELIM (BR_PHYS_ADDR((CONFIG_SYS_FLASH_BASE_PHYS)) \
                                | BR_PS_16 | BR_V)
#define CONFIG_FLASH_OR_PRELIM	(CONFIG_FLASH_OR_AM | OR_GPCM_BCTLD \
                                 | OR_GPCM_CSNT \
                                 | OR_GPCM_SCY_3 \
                                 | OR_GPCM_TRLX )

#define CONFIG_SYS_FLASH_BANKS_LIST	{CONFIG_SYS_FLASH_BASE_PHYS}
#define CONFIG_SYS_FLASH_QUIET_TEST
#define CONFIG_FLASH_SHOW_PROGRESS	45	/* count down from 45/5: 9..1 */

#define CONFIG_SYS_MAX_FLASH_BANKS	1	/* number of banks */

#undef CONFIG_SYS_FLASH_CHECKSUM
#define CONFIG_SYS_FLASH_ERASE_TOUT	60000	/* Flash Erase Timeout (ms) */
#define CONFIG_SYS_FLASH_WRITE_TOUT	500	/* Flash Write Timeout (ms) */

#define CONFIG_FLASH_CFI_DRIVER
#define CONFIG_SYS_FLASH_CFI
#define CONFIG_SYS_FLASH_CFI_POWER_PROTECT /* use power management, when writing and erasing */
#define CONFIG_SYS_FLASH_EMPTY_INFO
#define CONFIG_SYS_FLASH_USE_BUFFER_WRITE  /* use buffered writes (faster) */
#define CONFIG_SYS_FLASH_AUTOPROTECT_LIST	{ {CONFIG_ENV_ADDR, CONFIG_ENV_SECT_SIZE}, \
											  {CONFIG_MAC_ADDR, CONFIG_MAC_SECT_SIZE}, \
											  {CONFIG_2NDBOOT_ADDR,CONFIG_2NDBOOT_SECT_SIZE},\
											  {CONFIG_SYS_TEXT_BASE, CONFIG_SYS_TEXT_SECT_SIZE} }

#define CONFIG_MISC_INIT_R
#define CONFIG_BOARD_EARLY_INIT_R	/* call board_early_init_r function */

#define CONFIG_SYS_INIT_RAM_LOCK
#define CONFIG_SYS_INIT_RAM_ADDR	0xffd00000 /* stack in RAM */
#define CONFIG_SYS_INIT_RAM_ADDR_PHYS	CONFIG_SYS_INIT_RAM_ADDR /* Initial L1 address */
#define CONFIG_SYS_INIT_RAM_ADDR_PHYS_HIGH 0
#define CONFIG_SYS_INIT_RAM_ADDR_PHYS_LOW CONFIG_SYS_INIT_RAM_ADDR_PHYS
#define CONFIG_SYS_INIT_RAM_SIZE	0x00004000 /* Size of used area in RAM */

#define CONFIG_SYS_GBL_DATA_OFFSET	(CONFIG_SYS_INIT_RAM_SIZE - GENERATED_GBL_DATA_SIZE)
#define CONFIG_SYS_INIT_SP_OFFSET	CONFIG_SYS_GBL_DATA_OFFSET

#define CONFIG_SYS_MONITOR_LEN	(256 * 1024)/* Reserve 256 kB for Mon */
#define CONFIG_SYS_MALLOC_LEN	(1024 * 1024)/* Reserved for malloc */

/*CPLD(FPGA)*/
#define CONFIG_SYS_CPLD_BASE	0xfc000000
#define CONFIG_SYS_CPLD_BASE_PHYS	CONFIG_SYS_CPLD_BASE
#define CONFIG_CPLD_BR_PRELIM	(BR_PHYS_ADDR(CONFIG_SYS_CPLD_BASE_PHYS) | \
                                 BR_MS_GPCM | BR_PS_8 | BR_V)
#define CONFIG_CPLD_OR_PRELIM	(OR_AM_64KB | OR_GPCM_BCTLD \
                                 | OR_GPCM_CSNT \
                                 | OR_GPCM_SCY_2 \
                                 | OR_GPCM_TRLX | OR_GPCM_EAD)
/*SRAM*/
#define CONFIG_SYS_SRAM_BASE	0xf9000000
#define CONFIG_SYS_SRAM_SIZE	0x200000
#define CONFIG_SYS_SRAM_BASE_PHYS	CONFIG_SYS_SRAM_BASE
#define CONFIG_SRAM_BR_PRELIM	(BR_PHYS_ADDR(CONFIG_SYS_SRAM_BASE_PHYS) | \
                                 BR_MS_GPCM | BR_PS_16 | BR_V)
#define CONFIG_SRAM_OR_PRELIM	(OR_AM_2MB | OR_GPCM_BCTLD \
                                 | OR_GPCM_CSNT \
                                 | OR_GPCM_SCY_2 \
                                 | OR_GPCM_TRLX | OR_GPCM_EAD)

/*DSP: UPM - Host DMA Interface*/
#define CONFIG_SYS_DSP_BASE		0xfb000000
#define CONFIG_SYS_DSP_BASE_PHYS	CONFIG_SYS_DSP_BASE
#define CONFIG_DSP_BR_PRELIM	(BR_PHYS_ADDR(CONFIG_SYS_DSP_BASE_PHYS) | \
                                 BR_MS_UPMA | BR_PS_16 | BR_V)
#define CONFIG_DSP_OR_PRELIM	(OR_AM_64KB | OR_GPCM_BCTLD | OR_UPM_BI )



#define CONFIG_SYS_BR0_PRELIM	CONFIG_FLASH_BR_PRELIM	/* NOR Base Address */
#define CONFIG_SYS_OR0_PRELIM	CONFIG_FLASH_OR_PRELIM	/* NOR Options */
#define CONFIG_SYS_BR1_PRELIM	CONFIG_SRAM_BR_PRELIM	/* SRAM Base Address */
#define CONFIG_SYS_OR1_PRELIM	CONFIG_SRAM_OR_PRELIM	/* SRAM Options */
#define CONFIG_SYS_BR2_PRELIM	CONFIG_CPLD_BR_PRELIM	/* CPLD Base Address */
#define CONFIG_SYS_OR2_PRELIM	CONFIG_CPLD_OR_PRELIM	/* CPLD Options */
#define CONFIG_SYS_BR3_PRELIM	CONFIG_DSP_BR_PRELIM	/* DSP Base Address */
#define CONFIG_SYS_OR3_PRELIM	CONFIG_DSP_OR_PRELIM	/* DSP Options */


/* Serial Port - controlled on board with jumper J8
 * open - index 2
 * shorted - index 1
 */
#define CONFIG_CONS_INDEX		1
#undef CONFIG_SERIAL_SOFTWARE_FIFO
#define CONFIG_SYS_NS16550
#define CONFIG_SYS_NS16550_SERIAL
#define CONFIG_SYS_NS16550_REG_SIZE	1
#define CONFIG_SYS_NS16550_CLK		get_bus_freq(0)
#ifdef CONFIG_NAND_SPL
#define CONFIG_NS16550_MIN_FUNCTIONS
#endif

#define CONFIG_SYS_BAUDRATE_TABLE	\
	{300, 600, 1200, 2400, 4800, 9600, 19200, 38400, 57600, 115200}

#define CONFIG_SYS_NS16550_COM1	(CONFIG_SYS_CCSRBAR+0x4500)

/* Use the HUSH parser */
#define CONFIG_SYS_HUSH_PARSER
#ifdef CONFIG_SYS_HUSH_PARSER
#define CONFIG_SYS_PROMPT_HUSH_PS2 "> "
#endif

/*
 * Pass open firmware flat tree
 */
#define CONFIG_OF_LIBFDT
#define CONFIG_OF_BOARD_SETUP
#define CONFIG_OF_STDOUT_VIA_ALIAS

#define CONFIG_SYS_64BIT_VSPRINTF
#define CONFIG_SYS_64BIT_STRTOUL


/* new uImage format support */
#define CONFIG_FIT
#define CONFIG_FIT_VERBOSE	/* enable fit_format_{error,warning}() */

/* I2C */

/*
 * I2C2 EEPROM
 */
#undef CONFIG_ID_EEPROM

/*
 * eSPI - Enhanced SPI
 */
#define CONFIG_HARD_SPI
#define CONFIG_FSL_ESPI

#if defined(CONFIG_SPI_FLASH)
/* Cyclone4 E FPGA Configuration ROM - EPCS8(M25P80)
 * Memory map (sect size:256*256)
 * 0_0000	-	 0_FFFF		SECT00	    Page0: Boot Configuration(compress)
 * :			 :				:		:
 * 3_0000	-	 3_FFFF		    03	    :
 * 4_0000	-	 4_FFFF		SECT04	    Page1: Application1 Configuration
 * :			 :				:		:
 * 9_0000	-	 9_FFFF		    09	    :
 * A_0000	-	 A_FFFF		SECT10	    Page2: Application2 Configuration
 * :			 :				:		:
 * F_0000	-	 F_FFFF		    15		:
 */
#define CONFIG_SPI_FLASH_STMICRO
#define CONFIG_CMD_SF
#define CONFIG_SF_DEFAULT_SPEED	10000000
#define CONFIG_SF_DEFAULT_MODE	0
#endif

/*
 * MAC Flash
 */
#define CONFIG_MAC_ADDR_OFFSET 16


#if defined(CONFIG_TSEC_ENET)

#ifndef CONFIG_NET_MULTI
#define CONFIG_NET_MULTI
#endif

#define CONFIG_MII		/* MII PHY management */
#define CONFIG_TSEC3
#define CONFIG_TSEC3_NAME	"eTSEC3"

#define TSEC3_PHY_ADDR	0

#define TSEC3_FLAGS	(TSEC_GIGABIT | TSEC_REDUCED)

#define CONFIG_ETHPRIME	"eTSEC3"

#define CONFIG_PHY_GIGE	1	/* Include GbE speed/duplex detection */

#define CONFIG_HAS_ETH1
#endif /* CONFIG_TSEC_ENET */



/*
 * Environment
 */
#define CONFIG_ENV_IS_IN_FLASH
#define CONFIG_ENV_ADDR			CONFIG_SYS_FLASH_BASE	/*top sector*/
 #define CONFIG_ENV_SECT_SIZE	0x20000 /* 128K (one sector) */
#define CONFIG_ENV_SIZE			0x2000

#define CONFIG_LOADS_ECHO		/* echo on for serial download */
#define CONFIG_SYS_LOADS_BAUD_CHANGE	/* allow baudrate change */

/*
 * Command line configuration.
 */
#include <config_cmd_default.h>

#define CONFIG_CMD_IRQ
#define CONFIG_CMD_PING
#define CONFIG_CMD_MII
#define CONFIG_CMD_ELF
#define CONFIG_CMD_SETEXPR
#define CONFIG_CMD_REGINFO
#define CONFIG_CMD_UNZIP

/*
 * USB
 */
#define CONFIG_USB_EHCI

#ifdef CONFIG_USB_EHCI
#define CONFIG_CMD_USB
#define CONFIG_EHCI_HCD_INIT_AFTER_RESET
#define CONFIG_USB_EHCI_FSL
#define CONFIG_USB_STORAGE
#define CONFIG_HAS_FSL_DR_USB
#endif

/*
 * MMC/SDHC
 */
#define CONFIG_MMC

#ifdef CONFIG_MMC
#define CONFIG_FSL_ESDHC
#define CONFIG_SYS_FSL_ESDHC_ADDR	CONFIG_SYS_MPC85xx_ESDHC_ADDR
#define CONFIG_CMD_MMC
#define CONFIG_GENERIC_MMC
#endif

/*
 * FileSystem
 */
#if defined(CONFIG_MMC) || defined(CONFIG_USB_EHCI) \
		 || defined(CONFIG_FSL_SATA)
#define CONFIG_CMD_EXT2
#define CONFIG_CMD_FAT
#define CONFIG_DOS_PARTITION
#endif

#undef CONFIG_WATCHDOG	/* watchdog disabled */

/*
 * Miscellaneous configurable options
 */
#define CONFIG_SYS_LONGHELP			/* undef to save memory */
#define CONFIG_CMDLINE_EDITING			/* Command-line editing */
#define CONFIG_AUTO_COMPLETE			/* add autocompletion support */
#define CONFIG_SYS_LOAD_ADDR	0x2000000	/* default load address */
#define CONFIG_SYS_PROMPT	"CCPU=> "		/* Monitor Command Prompt */
#if defined(CONFIG_CMD_KGDB)
#define CONFIG_SYS_CBSIZE	1024		/* Console I/O Buffer Size */
#else
#define CONFIG_SYS_CBSIZE	256		/* Console I/O Buffer Size */
#endif
#define CONFIG_SYS_PBSIZE (CONFIG_SYS_CBSIZE + sizeof(CONFIG_SYS_PROMPT) + 16)
	/* Print Buffer Size */
#define CONFIG_SYS_MAXARGS	16	/* max number of command args */
#define CONFIG_SYS_BARGSIZE	CONFIG_SYS_CBSIZE/* Boot Argument Buffer Size */
#define CONFIG_SYS_HZ		1000	/* decrementer freq: 1ms tick */
#define CONFIG_SYS_M88E1510_ERRATA_REVA0
#define CONFIG_SYS_M88E1510_LEDCTRL
#define CONFIG_SYS_FLASH_CFI_AMD_RESET /* needed for STM_ID_29W128G on CCPU */
#undef CONFIG_SHOW_ACTIVITY

/*
 * For booting Linux, the board info and command line data
 * have to be in the first 16 MB of memory, since this is
 * the maximum mapped by the Linux kernel during initialization.
 */
#define CONFIG_SYS_BOOTMAPSZ	(16 << 20)	/* Initial Memory map for Linux*/
#define CONFIG_SYS_BOOTM_LEN	(16 << 20)	/* Increase max gunzip size */

#if defined(CONFIG_CMD_KGDB)
#define CONFIG_KGDB_BAUDRATE	230400	/* speed to run kgdb serial port */
#define CONFIG_KGDB_SER_INDEX	2	/* which serial port to use */
#endif

/*
 * Environment Configuration
 */
#define CONFIG_HOSTNAME			unknown
#define CONFIG_ROOTPATH			/srv/nfs/rootfs
#define CONFIG_BOOTFILE			uImage
#define CONFIG_UBOOTPATH		u-boot.bin	/* U-Boot image on TFTP server */
#define CONFIG_2ND_BOOTPATH		2ndboot 	/* 2nd Boot on TFTP server */

/*Default: application erea*/
#define CONFIG_FPGA_A_PATH		fpgaa.bin	/* FPGA Application Configuration File */
#define CONFIG_FPGA_A_ADDR		40000		/* FPGA Application Config ROM Offset  */
#define CONFIG_FPGA_A_SIZE		C0000		/* FPGA Application Config ROM Size    */

#define CONFIG_FPGA_B_PATH		fpgab.bin	/* FPGA Boot Configuration File */
#define CONFIG_FPGA_B_ADDR		0			/* FPGA Boot Config ROM Offset  */
#define CONFIG_FPGA_B_SIZE		40000		/* FPGA Boot Config ROM Size    */

#define CONFIG_FPGA_M_PATH		fpgam.bin	/* FPGA Master Configuration File      */
#define CONFIG_FPGA_M_ADDR		0			/* FPGA Config ROM Offset(Top)         */
#define CONFIG_FPGA_M_SIZE		100000		/* FPGA Config ROM Size  (Full 8Mbits) */

/* default location for tftp and bootm */
#define CONFIG_LOADADDR	1000000

#define CONFIG_BOOTDELAY 1	/* -1 disables auto-boot */
#define CONFIG_AUTOBOOT_KEYED		/* use key strings to stop autoboot	*/
#define CONFIG_AUTOBOOT_STOP_STR	"M"	/* easy to stop for now	*/
#define CONFIG_AUTOBOOT_PROMPT \
	"autoboot in %d seconds (stop with '%s')...\n", bootdelay, CONFIG_AUTOBOOT_STOP_STR
#define CONFIG_BOOTARGS	/* the boot command will set bootargs */

#define CONFIG_BAUDRATE	115200

#define CONFIG_IPADDR           192.168.0.254
#define CONFIG_SERVERIP         192.168.0.80

#define CONFIG_EXTRA_ENV_SETTINGS	\
 "download_ftp=tftpboot\0"				\
 "download_usb=fatload\0"	\
 "netdev=eth0\0"	\
 "consoledev=ttyS0\0"				\
 "fdtaddr=c00000\0"	\
 "fdtfile=ccpu.dtb\0"		\
 "othbootargs=ramdisk_size=120000\0" \
 "2ndboot=" MK_STR(CONFIG_2ND_BOOTPATH) "\0"	\
 "2ndbootaddr=" MK_STR(CONFIG_2NDBOOT_ADDR) "\0" \
 "fpga=" MK_STR(CONFIG_FPGA_A_PATH) "\0"	\
 "fpgaaddr=" MK_STR(CONFIG_FPGA_A_ADDR) "\0"	\
 "fpgasize=" MK_STR(CONFIG_FPGA_A_SIZE) "\0"	\
 "uboot=" MK_STR(CONFIG_UBOOTPATH) "\0"	\
 "loadaddr=1000000\0"	\
 "bootfile=uImage\0"	\
 "update_boot=if test $? -eq 0; then "\
	  "protect off " MK_STR(CONFIG_SYS_TEXT_BASE) " +$filesize;"\
	  "erase " MK_STR(CONFIG_SYS_TEXT_BASE) " +$filesize;"\
	  "cp.b $loadaddr " MK_STR(CONFIG_SYS_TEXT_BASE) " $filesize;"\
	  "protect on " MK_STR(CONFIG_SYS_TEXT_BASE) " +$filesize;"\
	  "cmp.b $loadaddr " MK_STR(CONFIG_SYS_TEXT_BASE) " $filesize;"\
	"fi\0"\
 "update_2ndb=if test $? -eq 0; then "\
	  "protect off " MK_STR(CONFIG_2NDBOOT_ADDR) " +$filesize;"\
	  "erase " MK_STR(CONFIG_2NDBOOT_ADDR) " +$filesize;"\
	  "cp.b $loadaddr " MK_STR(CONFIG_2NDBOOT_ADDR) " $filesize;"\
	  "protect on " MK_STR(CONFIG_2NDBOOT_ADDR) " +$filesize;"\
	  "cmp.b $loadaddr " MK_STR(CONFIG_2NDBOOT_ADDR) " $filesize;"\
	"fi\0"\
 "fpgab=echo *** FPGA Boot Release Setup ***;"   \
	  "setenv fpga " MK_STR(CONFIG_FPGA_B_PATH) ";"	\
	  "setenv fpgaaddr " MK_STR(CONFIG_FPGA_B_ADDR) ";"	\
	  "setenv fpgasize " MK_STR(CONFIG_FPGA_B_SIZE) ";"	\
	  "echo File  :$fpga; echo Offset:$fpgaaddr - Size:$fpgasize\0"	\
 "fpgam=echo *** FPGA Master Release Setup ***;"   \
	  "setenv fpga " MK_STR(CONFIG_FPGA_M_PATH) ";"	\
	  "setenv fpgaaddr " MK_STR(CONFIG_FPGA_M_ADDR) ";"	\
	  "setenv fpgasize " MK_STR(CONFIG_FPGA_M_SIZE) ";"	\
	  "echo File  :$fpga; echo Offset:$fpgaaddr - Size:$fpgasize\0"	\
 "update_fpga=if test $? -eq 0; then "\
	  "sf probe 0;" \
      "echo Write address: 0x$fpgaaddr - size:0x$fpgasize;" \
	  "sf pwrprotect on;" \
	  "sf erase $fpgaaddr $fpgasize;" \
	  "sf write $loadaddr $fpgaaddr $filesize;" \
	  "sf pwrprotect off;" \
	  "sf read 2000000 $fpgaaddr $filesize;" \
	  "cmp.b $loadaddr 2000000 $filesize;" \
	"fi\0"\
 "tftpflash=$download_ftp $loadaddr $uboot;"	\
	"run update_boot\0" \
 "usbflash=usb start; $download_usb usb 0:1 $loadaddr $uboot;"	\
	"run update_boot\0" \
 "tftp2ndbflash=$download_ftp $loadaddr ${2ndboot};"	\
	"run update_2ndb\0" \
 "usb2ndbflash=usb start; $download_usb usb 0:1 $loadaddr ${2ndboot};"	\
	"run update_2ndb\0" \
 "tftpfpgaflash=$download_ftp $loadaddr $fpga;"	\
	"run update_fpga\0" \
 "usbfpgaflash=usb start; $download_usb usb 0:1 $loadaddr $fpga;"	\
	"run update_fpga\0" \
 "sdboot=setenv bootargs root=/dev/mmcblk0p1 rw "	\
	"rootdelay=10 "	\
	"console=$consoledev,$baudrate $othbootargs; " \
	"mmcinfo; "	\
	"ext2load mmc 0:1 $loadaddr /boot/$bootfile; "	\
	"ext2load mmc 0:1 $fdtaddr  /boot/$fdtfile; "	\
	"bootm $loadaddr - $fdtaddr\0" \
 "hwconfig=usb1:dr_mode=host,phy_type=ulpi;ddr3:ecc=on\0"

#define CONFIG_NFSBOOTCOMMAND	\
 "setenv bootargs root=/dev/nfs rw "	\
 "nfsroot=$serverip:$rootpath "	\
 "ip=$ipaddr:$serverip:$gatewayip:$netmask:$hostname:$netdev:off " \
 "console=$consoledev,$baudrate $othbootargs;" \
 "tftp $loadaddr $bootfile;"	\
 "tftp $fdtaddr $fdtfile;"	\
 "bootm $loadaddr - $fdtaddr"

#define CONFIG_HDBOOT	"bootelf ${2ndbootaddr}"

#define CONFIG_BOOTCOMMAND	CONFIG_HDBOOT

#endif /* __CONFIG_H */
